; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    filecmp_heapbuffers PROTO :DWORD,:DWORD
    filecmp_filemapping PROTO :DWORD,:DWORD
    filecmp_nobuffering PROTO :DWORD,:DWORD
; 
    .data
      testfile db "\masm32\include\windows.inc",0
    .code
; 
start:
; 
    print "correct return vals: 1 0 0 0 -1 -1 1",13,10
    print "filecmp_heapbuffers: "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file2.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file3.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file4.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("filex.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("filex.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers,ADDR testfile,ADDR testfile
    print str$(eax),13,10
    print "filecmp_filemapping: "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file2.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file3.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file4.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("filex.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("filex.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_filemapping,ADDR testfile,ADDR testfile
    print str$(eax),13,10,13,10

    print "filecmp_nobuffering: x x x x  x  x "
    invoke filecmp_nobuffering,ADDR testfile,ADDR testfile
    print str$(eax),13,10,13,10

    LOOP_COUNT equ 100
    print "filecmp_heapbuffers: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_heapbuffers,ADDR testfile,ADDR testfile
    timer_end
    push eax    
    print ustr$(eax),"ms",13,10

    print "filecmp_filemapping: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_filemapping,ADDR testfile,ADDR testfile
    timer_end
    push eax
    print ustr$(eax),"ms",13,10,13,10

    fild DWORD PTR[esp]
    fild DWORD PTR[esp+4]
    fdiv
    fld8 100.0
    fmul
    fstp QWORD PTR[esp]
    pop eax
    pop edx

    invoke crt_printf,chr$("%.1f%%%c%c"),edx::eax,10,10

    invoke Sleep,1000

    print "filecmp_nobuffering: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_nobuffering,ADDR testfile,ADDR testfile
    timer_end
    push eax
    print ustr$(eax),"ms",13,10,13,10

    inkey "Press any key to exit..."
    exit

; 
; This proc performs a binary comparison of two files, returning 0
; if the files are different, 1 if the files are byte identical, or
; INVALID_HANDLE_VALUE (-1) if there is a problem opening either
; of the files.
; 

filecmp_heapbuffers proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,lpMem2:DWORD
    LOCAL bytesRead:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetFileSize,hFile1,NULL
    mov lof1, eax
    invoke GetFileSize,hFile2,NULL
    mov lof2, eax

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    invoke GetProcessHeap
    push eax
    invoke HeapAlloc,eax,0,lof1
    mov lpMem1, eax
    pop eax
    invoke HeapAlloc,eax,0,lof1
    mov lpMem2, eax

    invoke ReadFile,hFile1,lpMem1,lof1,ADDR bytesRead,NULL
    invoke ReadFile,hFile2,lpMem2,lof1,ADDR bytesRead,NULL

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke GetProcessHeap
    push eax
    invoke HeapFree,eax,0,lpMem1
    pop eax
    invoke HeapFree,eax,0,lpMem2

  @@:
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_heapbuffers endp

; 
; This proc performs a binary comparison of two files, returning
; 0 if the files are different, 1 if the files are byte identical,
; or INVALID_HANDLE_VALUE (-1) if there is a problem opening
; either of the files.
; 
filecmp_filemapping proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,hMMF1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,hMMF2:DWORD,lpMem2:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetFileSize,hFile1,NULL
    mov lof1, eax
    invoke GetFileSize,hFile2,NULL
    mov lof2, eax

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    mov hMMF1, rv(CreateFileMapping,hFile1,NULL,PAGE_READWRITE,0,0,NULL)
    mov lpMem1, rv(MapViewOfFile,hMMF1,FILE_MAP_WRITE,0,0,0)
    mov hMMF2, rv(CreateFileMapping,hFile2,NULL,PAGE_READWRITE,0,0,NULL)
    mov lpMem2, rv(MapViewOfFile,hMMF2,FILE_MAP_WRITE,0,0,0)

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke UnmapViewOfFile,lpMem1
    invoke UnmapViewOfFile,lpMem2
    invoke CloseHandle,hMMF1
    invoke CloseHandle,hMMF2

  @@:    
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_filemapping endp

; 

filecmp_nobuffering proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,lpMem2:DWORD
    LOCAL bytesRead:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetFileSize,hFile1,NULL
    and eax, 0fffffe00h             ; truncate to multiple of 512
    mov lof1, eax
    invoke GetFileSize,hFile2,NULL
    and eax, 0fffffe00h             ; truncate to multiple of 512
    mov lof2, eax

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    invoke VirtualAlloc,NULL,lof1,MEM_COMMIT,PAGE_READWRITE
    mov lpMem1, eax
    ;;print ustr$(eax)," rv VirtualAlloc",13,10
    invoke VirtualAlloc,NULL,lof1,MEM_COMMIT,PAGE_READWRITE
    mov lpMem2, eax
    ;;print ustr$(eax)," rv VirtualAlloc",13,10

    invoke ReadFile,hFile1,lpMem1,lof1,ADDR bytesRead,NULL
    invoke ReadFile,hFile2,lpMem2,lof1,ADDR bytesRead,NULL

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke VirtualFree,lpMem1,0,MEM_RELEASE
    ;;print ustr$(eax)," rv VirtualFree",13,10
    invoke VirtualFree,lpMem2,0,MEM_RELEASE
    ;;print ustr$(eax)," rv VirtualFree",13,10

  @@:
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_nobuffering endp

; 
end start
 